Debian Bug report logs - #118787
request for dh_adduser

version graph

Package: debhelper; Maintainer for debhelper is Debhelper Maintainers <debhelper-devel@lists.alioth.debian.org>; Source for debhelper is src:debhelper.

Reported by: Adam Heath <doogie@debian.org>

Date: Thu, 8 Nov 2001 20:18:04 UTC

Severity: wishlist

Merged with 81697

Found in versions 2.2.11, 3.0.44

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <doogie@debian.org>:
New Bug report received and forwarded. Copy sent to Joey Hess <joeyh@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Adam Heath <doogie@debian.org>
To: <submit@bugs.debian.org>
Subject: request for dh_adduser
Date: Thu, 8 Nov 2001 14:13:13 -0600 (CST)
package: debhelper
Version: 3.0.44
Severity: wishlist

It would be nice if there was a dh_adduser, that added appropriate snippets to
postinst, and postrm, for creating/purging users.  In addition to creating
users(and groups), it should also supports chmod/chown of a list of
directories.





Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <adam@doogie.org>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. Full text and rfc822 format available.

Message #10 received at 118787@bugs.debian.org (full text, mbox):

From: Adam Heath <adam@doogie.org>
To: <118787@bugs.debian.org>
Cc: <control@bugs.debian.org>
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Thu, 8 Nov 2001 16:14:07 -0600 (CST)
[Message part 1 (text/plain, inline)]
merge 118787 81697
tags 118787 + patch
thanks

Attached you will find a tarball, that contains some autoscripts, an example
.adduser file, and the script itself.  It has pod documentation as well.
[dh_adduser.tar.gz (application/octet-stream, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #15 received at 118787@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Adam Heath <adam@doogie.org>, 118787@bugs.debian.org
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Thu, 8 Nov 2001 18:26:54 -0500
Adam Heath wrote:
> Attached you will find a tarball, that contains some autoscripts, an example
> .adduser file, and the script itself.  It has pod documentation as well.

There are two things here I dislike:

1. The config file format is far more complicated than any config file
   currently in debhelper. I tend to feel that if a lot of information
   like this needs to be specified, the problem is sufficiently complex
   and has enough wrinkles that making debhelper try to support all of
   them is not productive. The most complex config file currently in use
   by debhelper is dh_link's file, which has pairs of elements. This
   would be a vast step up.
   FWIW, I put off adding dh_installinfo, which was long suspected to
   need a lot of complex options in a config file to work, until someone
   came up with the bright idea of requiring the info file have all the
   (correct) info in it, and parsing out things like the section and so
   on. I think some kind of similar outside the box thinking is needed
   here, but I don't have any bright ideas.
   This is why I never implemented bug #81697, BTW.
2. The directory chmodding seems like something almost nobody would ever
   use. It is not any easier or better than adding chmod/chown -R lines to
   your postinst by hand, and merely makes the user learn a new way to do 
   that, which increases the learning curve for no good reason.

-- 
see shy jo



Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <adam@doogie.org>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. Full text and rfc822 format available.

Message #20 received at 118787@bugs.debian.org (full text, mbox):

From: Adam Heath <adam@doogie.org>
Cc: <118787@bugs.debian.org>
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Thu, 8 Nov 2001 18:05:49 -0600 (CST)
On Thu, 8 Nov 2001, Joey Hess wrote:

> Adam Heath wrote:
> > Attached you will find a tarball, that contains some autoscripts, an example
> > .adduser file, and the script itself.  It has pod documentation as well.
>
> There are two things here I dislike:
>
> 1. The config file format is far more complicated than any config file
>    currently in debhelper. I tend to feel that if a lot of information
>    like this needs to be specified, the problem is sufficiently complex
>    and has enough wrinkles that making debhelper try to support all of
>    them is not productive. The most complex config file currently in use
>    by debhelper is dh_link's file, which has pairs of elements. This
>    would be a vast step up.

The format is really just a bunch of 'var=value' pairs.  If you follow the
code, you will see that it does very little checking on the input, so that
someone could use any long option of adduser(foo=bar -> --foo bar).

> 2. The directory chmodding seems like something almost nobody would ever
>    use. It is not any easier or better than adding chmod/chown -R lines to
>    your postinst by hand, and merely makes the user learn a new way to do
>    that, which increases the learning curve for no good reason.

I agree.  You can drop that part, as it really isn't related to adding users.
Some might even argue that the chmod'ing should be done in the init script.




Merged 81697 118787. Request was from Joey Hess <joeyh@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Marc Haber <mh+debian-bugs@zugschlus.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. Full text and rfc822 format available.

Message #27 received at 118787@bugs.debian.org (full text, mbox):

From: Marc Haber <mh+debian-bugs@zugschlus.de>
To: Joey Hess <joeyh@debian.org>
Cc: 118787@bugs.debian.org
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Wed, 17 Mar 2004 17:29:59 +0100
On Thu, Nov 08, 2001 at 06:26:54PM -0500, Joey Hess wrote:
> Adam Heath wrote:
> > Attached you will find a tarball, that contains some autoscripts, an example
> > .adduser file, and the script itself.  It has pod documentation as well.
> 
> There are two things here I dislike:
> 
> 1. The config file format is far more complicated than any config file
>    currently in debhelper. I tend to feel that if a lot of information
>    like this needs to be specified, the problem is sufficiently complex
>    and has enough wrinkles that making debhelper try to support all of
>    them is not productive. The most complex config file currently in use
>    by debhelper is dh_link's file, which has pairs of elements. This
>    would be a vast step up.

Yes, it would be, but it is the right thing to do. We are getting more
and more security conscious nowadays, and it is quite common that
important packages (ssh, exim4 the most prominent examples, console-log
being a less important one) create their own accounts on installation.
Judging from the sheer amount of bug reports coming in for exim4's
account creation code, account creation and deletion is extremely hard
to get right, making the idea of having shared code that is easily
changed interesting. That way, individual package maintainers
shouldn't have to re-invent this particular wheel over and over again.

Having dh_adduser in stock debhelper will help improving Debian's over
all robustness and software quality. In my opinion, the price - having
a complicated config file - is cheap when compared to the potential
gain.

>    FWIW, I put off adding dh_installinfo, which was long suspected to
>    need a lot of complex options in a config file to work, until someone
>    came up with the bright idea of requiring the info file have all the
>    (correct) info in it, and parsing out things like the section and so
>    on. I think some kind of similar outside the box thinking is needed
>    here, but I don't have any bright ideas.

dh_adduser is quite unique in the debhelper scripts since it doesn't
actually do any installation to the package. Its only purpose is to
modify the maintainer scripts. There has to be one way to get the
needed information into dh_adduser, and in the absence of any files to
be installed and hence the absence of data where we could piggy-back
ours on, there is only the dh_adduser command line and the config file
left. Allowing the command line would mean a change to Dh_Getopts.pm
(#112349), so the config file is the only thing left.

Please reconsider your decision about the config file. I really find
that dh_adduser is helpful, and that Debian needs it.

> 2. The directory chmodding seems like something almost nobody would ever
>    use. It is not any easier or better than adding chmod/chown -R lines to
>    your postinst by hand, and merely makes the user learn a new way to do 
>    that, which increases the learning curve for no good reason.

You're right here, that part could be removed, or implemented as a
dedicated dh_script (#155931).

Please let us know how you'd decide, by either applying the patch to
debhelper (after some modernisations, the patch is way over two years
old), or by tagging this bug as wontfix so that people can take their
own measures to get a standarized account-creation framework into the
Distribution.

Greetings
Marc

-- 
-----------------------------------------------------------------------------
Marc Haber         | "I don't trust Computers. They | Mailadresse im Header
Karlsruhe, Germany |  lose things."    Winona Ryder | Fon: *49 721 966 32 15
Nordisch by Nature |  How to make an American Quilt | Fax: *49 721 966 31 29



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #32 received at 118787@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Marc Haber <mh+debian-bugs@zugschlus.de>
Cc: 118787@bugs.debian.org
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Mon, 22 Mar 2004 19:17:39 -0500
[Message part 1 (text/plain, inline)]
Marc Haber wrote:
> Yes, it would be, but it is the right thing to do. We are getting more
> and more security conscious nowadays, and it is quite common that
> important packages (ssh, exim4 the most prominent examples, console-log
> being a less important one) create their own accounts on installation.

Raising the spectre of security is not going to make me any more likely
to add something this complicated and unlike the rest of debhelper to
debhelper.

> dh_adduser is quite unique in the debhelper scripts since it doesn't
> actually do any installation to the package. Its only purpose is to
> modify the maintainer scripts. There has to be one way to get the
> needed information into dh_adduser, and in the absence of any files to
> be installed and hence the absence of data where we could piggy-back
> ours on, there is only the dh_adduser command line and the config file
> left.

Yes, you're right. This suggests strongly that we need a standard
(probably data-driven) way to do it outside of debhelper, and then
debhelper can take care of installing the data files and adding calls to
the appropriate programs in the postinst, much as it does for the debian
menu system, info files, debconf, etc.

> Please let us know how you'd decide, by either applying the patch to
> debhelper (after some modernisations, the patch is way over two years
> old), or by tagging this bug as wontfix so that people can take their
> own measures to get a standarized account-creation framework into the
> Distribution.

I don't understand how this bug can posibly block someone getting such a
framework into Debian. If it existed, debhelper would probably quickly
use it.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. Full text and rfc822 format available.

Acknowledgement sent to Marc Haber <mh+debian-bugs@zugschlus.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. Full text and rfc822 format available.

Message #37 received at 118787@bugs.debian.org (full text, mbox):

From: Marc Haber <mh+debian-bugs@zugschlus.de>
To: Joey Hess <joeyh@debian.org>
Cc: 118787@bugs.debian.org
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Tue, 23 Mar 2004 21:52:14 +0100
On Mon, Mar 22, 2004 at 07:17:39PM -0500, Joey Hess wrote:
> I don't understand how this bug can posibly block someone getting such a
> framework into Debian.

Oh well. I have just submitted a bunch of patches against adduser, and
there is no debhelper change needed any more. With the modified
adduser (if its maintainer accepts my patches), the maintainer scripts
only need a single line per user. That can easily be done manually.

Thanks for commenting.

Greetings
Marc

-- 
-----------------------------------------------------------------------------
Marc Haber         | "I don't trust Computers. They | Mailadresse im Header
Karlsruhe, Germany |  lose things."    Winona Ryder | Fon: *49 721 966 32 15
Nordisch by Nature |  How to make an American Quilt | Fax: *49 721 966 31 29



Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. (Sat, 12 May 2012 11:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Sat, 12 May 2012 11:45:12 GMT) Full text and rfc822 format available.

Message #42 received at 118787@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: Marc Haber <mh+debian-bugs@zugschlus.de>, 118787@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Sat, 12 May 2012 12:40:50 +0100
On Tue, Mar 23, 2004 at 09:52:14PM +0100, Marc Haber wrote:
> On Mon, Mar 22, 2004 at 07:17:39PM -0500, Joey Hess wrote:
> > I don't understand how this bug can posibly block someone getting such a
> > framework into Debian.
> 
> Oh well. I have just submitted a bunch of patches against adduser, and
> there is no debhelper change needed any more. With the modified
> adduser (if its maintainer accepts my patches), the maintainer scripts
> only need a single line per user. That can easily be done manually.

What's the current status of this?  Is adduser now sufficient to
use standalone?  While most packages go this route, the lack of
consistency in its use, and the bugs this continues to cause
still makes me wish we had a standard, declarative, means of
creating users and groups with debhelper which all packages could
use to give complete consistency and reliability.

Is adding such a facility to debhelper still a possiblity?


Thanks,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.




Information forwarded to debian-bugs-dist@lists.debian.org, Joey Hess <joeyh@debian.org>:
Bug#118787; Package debhelper. (Sat, 12 May 2012 12:42:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Marc Haber <mh+debian-packages@zugschlus.de>:
Extra info received and forwarded to list. Copy sent to Joey Hess <joeyh@debian.org>. (Sat, 12 May 2012 12:42:08 GMT) Full text and rfc822 format available.

Message #47 received at 118787@bugs.debian.org (full text, mbox):

From: Marc Haber <mh+debian-packages@zugschlus.de>
To: Roger Leigh <rleigh@codelibre.net>, 118787@bugs.debian.org, 118787-submitter@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>
Subject: Re: Bug#118787: Acknowledgement (request for dh_adduser)
Date: Sat, 12 May 2012 14:13:10 +0200
On Sat, May 12, 2012 at 12:40:50PM +0100, Roger Leigh wrote:
> On Tue, Mar 23, 2004 at 09:52:14PM +0100, Marc Haber wrote:
> > On Mon, Mar 22, 2004 at 07:17:39PM -0500, Joey Hess wrote:
> > > I don't understand how this bug can posibly block someone getting such a
> > > framework into Debian.
> > 
> > Oh well. I have just submitted a bunch of patches against adduser, and
> > there is no debhelper change needed any more. With the modified
> > adduser (if its maintainer accepts my patches), the maintainer scripts
> > only need a single line per user. That can easily be done manually.
> 
> What's the current status of this?  Is adduser now sufficient to
> use standalone?

If one can live with piuparts error reports and strange warnings
during package installation, yes. I have arranged myself with that.

Eleven years after this bug was initially filed, I think that this
feature should be implemented not in debhelper, but in
dpkg-maintscript-helper, which has taken the responsibility of
implementing common maintscript actions in the mean time.

Greetings
Marc

-- 
-----------------------------------------------------------------------------
Marc Haber         | "I don't trust Computers. They | Mailadresse im Header
Mannheim, Germany  |  lose things."    Winona Ryder | Fon: *49 621 31958061
Nordisch by Nature |  How to make an American Quilt | Fax: *49 621 31958062




Message sent on to Adam Heath <doogie@debian.org>:
Bug#118787. (Sat, 12 May 2012 12:42:15 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 01:15:54 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.